
// transform properties are anything that might distort or reposition
// an entity. This includes rotations, x/y coords, width height, and 3D props
export const TRANSFORM  = 'transform';

// typography is anything that might affect the appearance of text such as letter
// spacing, line height, text color, etc
export const TYPOGRAPHY = 'typography';

// anything that might affect the appearance of the entity such as background color
// blend mode, etc
export const APPEARANCE = 'appearance';

// anything that might affect the entities that might affect neighboring entities. This
// includes properties such as display, flexbox, etc
export const LAYOUT     = 'layout';